/*--------------------------------------------------------------------------
--------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#define  XK_MISCELLANY
#include <X11/keysymdef.h>
#include <string.h>

const char hello[]="image";
Display *mydisplay;
Window mywindow;
GC mygc;
XEvent myevent;
XSizeHints myhint;
XWMHints mywmhint;
int myscreen;

void x11_init(int imgx,int imgy)
{

    mydisplay = XOpenDisplay("");
    if(mydisplay==NULL) {fprintf(stderr,"\033[2J\033[HCan't connect to %s\n",
			XDisplayName("")); getchar(); return;}
    myscreen = DefaultScreen(mydisplay);
    myhint.x=40;myhint.y=0;
    myhint.width=imgx;myhint.height=imgy;
    myhint.flags=PPosition|PSize;
    mywmhint.flags=InputHint;
    mywmhint.input=True;

    mywindow=XCreateSimpleWindow(mydisplay,
	DefaultRootWindow(mydisplay),
	myhint.x,myhint.y,myhint.width,myhint.height,
	5,0,0);
    XSetStandardProperties(mydisplay,mywindow,hello,hello,
    	None,NULL,0,&myhint);
    XSetWMHints(mydisplay,mywindow,&mywmhint);

    mygc=XCreateGC(mydisplay,mywindow,0,0);

    XSelectInput(mydisplay,mywindow,
	ButtonPressMask|KeyPressMask|ExposureMask);

    XMapRaised(mydisplay,mywindow);

    XFlush(mydisplay);
    usleep(100000);

}

void putpixel(int x,int y, int color)
{
        int c;
        color&=15;
        c=(color<<12)|(color<<7)|(color<<1);
        XSetForeground(mydisplay,mygc,c);
        XDrawPoint(mydisplay,mywindow,mygc,x,y);
        //XFlush(mydisplay);
}
