*==============================================================
*                      IMPORTANT NOTICE :
*==============================================================
* "helloW.asm" as been extracted from "whack.app" (basically
* taking out most of the code while retaining the minimum
* piece of program to display the famous sentence in the dV
* screen).
*
* "whack.app" was programed by Mark Tillotson (markt@ctf.com)
* who showed me how to build a running application for dV. Mark
* based in turn his work in "invert.app".
*
* "hellow.asm" is intended to show how a running app can be
* constructed with the free tools available in the Net.
*
* "hellow.asm" is a minimal application. Further apps can be
* posted to show other basic operations (display a bitmap,
* display a number, show time, catching taps, etc..)
*
* The following program contains several lines of code which
* even you can guess its purpose, it is not clear how do
* they exactly work. These lines are marked (?). If anybody
* can give some clue about them, it will be greatly appreciated.
*===============================================================
* How to make this program run in your dV :
*
* 0- IMPORTANT : MAKE SURE THAT YOU BACK UP ALL THE STUFF IN
*                YOUR daVinci !!!!!
*
* 0-bis : BE ALWAYS PREPARED FOR THE WORST (DATA LOSS, HANGUPS,
*         dV EXPLOSION *-), ETC...)
*
* 0-bis-bis : MAKE SURE THAT YOU HAVE READ 0-, 0-bis and 0-bis-bis
*
* 1- Prepare the dV icon files to be included with this file
*    at assembly time (see utilities and details in my page
*    www.ictnet.es/+jilari) and copy them in the same dir as
*    "hellow.asm" (this file) : "helloup.ico" and "hellodn.ico"
*
* 2- Assemble "hellow.asm" with "pila" assembler, freely downloadable
*    from ftp://ftp.micro.cc.utah.edu/pilot/asdk1a1.zip
*
* 3- Edit the resulting .prc file with an hex editor and take
*    out the first 100 bytes ($64). You can do a program to
*    automate this.
*
* 4- Rename the resulting file as "hellow.app".
*
* 5- Download "hellow.app" to your dV (or to the dV emulator
*    available at ftp://ftp.webcom.com/pub5/clink/ftp/dvemu.exe).
*
* ... and see the best known sentence in the history of software
*     in the screen of your dV.
*
*    Good luck !
*                  3th. may 1999      joan_ilari@eic.ictnet.es
*===================================================================
* AND NOW, THE REAL STUFF :

*------------------------------------------
* Assembler (pila) directives
*
hwlen   equ     15      *message length
hwx     equ     0       *message X position
hwy     equ     $45     *message Y position
*------------------------------------------
*
*==== CODE ====
*
	code

*============== Program header ====================================
*
*main :         starting address of program
*headstart :    starting address of header
*headend :      address of first byte after header
*datastart :    starting address of data section
*dataend:       address of first byte after data section
*appname:       address of application name as seen in the
*               preferences/memory/application list, 0-terminated
*               and 2 byte aligned
*appcreator:    address of application's creator name, 4 chars (?),
*               0-terminated and 2 byte aligned
*appversion:    address of application's version : 3 chars (?),
*               0-terminated
*appiconup:     address of the icon displayed in the application
*               directory
*appicondn:     address of the icon displayed in the application
*               directory when pressed with pen
headstart:
	dc.l	main-headend,0,0,0
	dc.l	0,1,headend-headstart,datastart-main
	dc.l	dataend-datastart,0,0,0
	dc.l	0,0,0,0
	dc.l	appname,appcreator,appversion,appiconup
	dc.l	appicondn,0,0,$ffffffff
headend:
*==================================================================

main:
        tst.w   6(a7)                   *(?) code borrowed from invert.app
	bne	exit

new:
        pea.l   4                       *set font
        bsr     setfont                 *values tested : 1 (tiny)
                                        * 2 (bold), 3 (normal)

        pea.l   $a0                     *(?) What's $a0 ?
	pea.l	hwlen
	pea.l	hwy
	pea.l	hwx
	pea.l	hw(pc)
        bsr     print                   *print message

        move.w  #$2700,sr               *No int's.
        move.l  #$ffffffff,$fffff304    *
        move.w  #$2420,$fffff200        *boot clocks

        jmp     $ffffff00               *bootloader code

exit:
        clr.l   d0                      *(?)
	movea.l	(a7)+,a0
	lea.l	$c(a7),a7
	jmp	(a0)


*---- System call addresses ----

print:	dc.w	$f009
setfont:dc.w	$f06f

*---- Message to display : 0 terminated and 2 byte aligned ---

hw:
        dc.b    'Serial Boot   ',0,0

*==== DATA ====

datastart:

appname:
        dc.b    'SerialBoot',0,0
appcreator:
	dc.b	'Hell',0,0
appversion:
	dc.b	'0.1',0
appiconup:
        dc.b $00,$30,$00,$28,$00,$06,$00,$00
	dc.b $00,$00,$00,$00,$00,$00,$00,$00
	dc.b $80,$00,$00,$00,$00,$00
	dc.b $40,$00,$00,$00,$00,$01
	dc.b $2A,$AA,$AA,$AA,$AA,$AA
	dc.b $00,$00,$00,$00,$00,$05
	dc.b $20,$00,$00,$00,$00,$02
	dc.b $00,$00,$00,$00,$00,$05
	dc.b $20,$78,$00,$00,$00,$02
	dc.b $00,$44,$00,$3F,$FF,$C5
	dc.b $23,$C2,$00,$20,$00,$42
	dc.b $03,$C1,$00,$2F,$FF,$45
	dc.b $20,$41,$00,$28,$01,$42
	dc.b $00,$41,$00,$2B,$9D,$45
	dc.b $23,$C1,$00,$2A,$95,$42
	dc.b $03,$C1,$38,$2B,$9D,$45
	dc.b $20,$41,$6C,$28,$01,$42
	dc.b $00,$41,$44,$28,$61,$45
	dc.b $23,$C1,$CC,$28,$61,$42
	dc.b $03,$C1,$88,$2A,$05,$45
	dc.b $20,$41,$88,$EA,$05,$42
	dc.b $00,$41,$98,$A9,$F9,$45
	dc.b $23,$C1,$91,$A8,$01,$42
	dc.b $03,$C1,$31,$28,$01,$45
	dc.b $20,$41,$21,$2F,$FF,$42
	dc.b $00,$41,$21,$20,$00,$45
	dc.b $23,$C1,$23,$22,$01,$42
	dc.b $03,$C1,$36,$27,$03,$C5
	dc.b $20,$41,$1C,$2A,$81,$42
	dc.b $00,$41,$00,$3D,$C0,$45
	dc.b $23,$C1,$00,$2A,$92,$42
	dc.b $03,$C2,$00,$27,$3F,$45
	dc.b $20,$44,$00,$22,$12,$42
	dc.b $00,$78,$00,$3F,$FF,$C5
	dc.b $20,$00,$00,$00,$00,$02
	dc.b $00,$00,$00,$00,$00,$05
	dc.b $20,$00,$00,$00,$00,$02
	dc.b $00,$00,$00,$00,$00,$05
	dc.b $20,$00,$00,$00,$00,$02
	dc.b $15,$55,$55,$55,$55,$55
	dc.b $2A,$AA,$AA,$AA,$AA,$AA
	dc.b $55,$55,$55,$55,$55,$55

appicondn:
        dc.b $00,$30,$00,$28,$00,$06,$00,$00
	dc.b $00,$00,$00,$00,$00,$00,$00,$00
	dc.b $80,$00,$00,$00,$00,$00
	dc.b $40,$00,$00,$00,$00,$01
	dc.b $2A,$AA,$AA,$AA,$AA,$AA
	dc.b $00,$00,$00,$00,$00,$05
	dc.b $20,$00,$00,$00,$00,$02
	dc.b $00,$00,$00,$00,$00,$05
	dc.b $20,$78,$00,$00,$00,$02
	dc.b $00,$44,$00,$3F,$FF,$C5
	dc.b $23,$C2,$00,$20,$00,$42
	dc.b $03,$C1,$00,$2F,$FF,$45
	dc.b $20,$47,$00,$28,$01,$42
	dc.b $00,$4F,$00,$28,$01,$45
	dc.b $23,$DD,$00,$2B,$0D,$42
	dc.b $03,$F9,$38,$28,$91,$45
	dc.b $20,$4F,$6C,$28,$01,$42
	dc.b $00,$4D,$44,$28,$61,$45
	dc.b $23,$D9,$CC,$28,$61,$42
	dc.b $03,$D1,$88,$28,$01,$45
	dc.b $20,$61,$88,$E8,$01,$42
	dc.b $00,$41,$98,$A9,$F9,$45
	dc.b $23,$C7,$91,$AA,$05,$42
	dc.b $03,$CF,$31,$28,$01,$45
	dc.b $20,$5D,$21,$2F,$FF,$42
	dc.b $00,$79,$21,$20,$00,$45
	dc.b $23,$CF,$23,$22,$01,$42
	dc.b $03,$CD,$36,$27,$03,$C5
	dc.b $20,$59,$1C,$2A,$81,$42
	dc.b $00,$51,$00,$3D,$C0,$45
	dc.b $23,$E1,$00,$2A,$92,$42
	dc.b $03,$C2,$00,$27,$3F,$45
	dc.b $20,$44,$00,$22,$12,$42
	dc.b $00,$78,$00,$3F,$FF,$C5
	dc.b $20,$00,$00,$00,$00,$02
	dc.b $00,$00,$00,$00,$00,$05
	dc.b $20,$00,$00,$00,$00,$02
	dc.b $00,$00,$00,$00,$00,$05
	dc.b $20,$00,$00,$00,$00,$02
	dc.b $15,$55,$55,$55,$55,$55
	dc.b $2A,$AA,$AA,$AA,$AA,$AA
	dc.b $55,$55,$55,$55,$55,$55

dataend:

	end
